#include <delays.h>
#include <i2c.h>
#include <stdlib.h>

char tnum[4],txt;

void start1307s(){
//START SIGNAL FOR DS1307***********
StartI2C1(); // issue start signal
WriteI2C1(0xD0); // address PCF8530
WriteI2C1(0); // start from word at address 0
WriteI2C1(0); // write 0 to config word (enable counting)
StopI2C1(); // issue stop signal
//**********************************
}


void readDS1307(char *sec, char *min, char *hr, char *week_day, char *day, char *mn, char *year)
    {
    
	StartI2C1();
	WriteI2C1(0xD0);
	WriteI2C1(0x00);
	RestartI2C1();
	WriteI2C1(0xD1); //<--- corrected here
	*sec = ReadI2C1();
	AckI2C1();
	*min = ReadI2C1();
   	AckI2C1();
	*hr = ReadI2C1();
 	AckI2C1();
	*week_day = ReadI2C1();
 	AckI2C1();
	*day = ReadI2C1();
 	AckI2C1();
	*mn = ReadI2C1();
 	AckI2C1();
	*year = ReadI2C1();
	NotAckI2C1();
	StopI2C1();

}


void writeDS1307()
 {
     StartI2C1();	
	WriteI2C1(0xD0);	
	WriteI2C1(0x00);	
	WriteI2C1(0x00);// sec
	WriteI2C1(0x58);//minutes	
	WriteI2C1(0x22);// hours	
	WriteI2C1(0x06);//week_day	
	WriteI2C1(0x22);//date	
    WriteI2C1(0x12);//month	
	WriteI2C1(0x13);//year
	
	WriteI2C1(0x10);   // REG 7 - Enable squarewave output pin1hz 
	 	
	Delay1KTCYx(25);
	StopI2C1();
	
//	StartI2C1();
//	WriteI2C1(0xD0);
//	WriteI2C1(0x00);
//	WriteI2C1(0x00); //minutes
//	Delay1KTCYx(25);
//	StopI2C1();
}


void Zero_Fill(char *value) { // fill text representation
if (value[1] == 0) { // with leading zero
value[1] = value[0];
value[0] = 48;
value[2] = 0;
}
}


// -------------------- Formats date and time
void Transform_Time(char *sec, char *min, char *hr, char *week_day, char *day, char *mn, char *year)
     {
*sec = ((*sec & 0x70) >> 4)*10 + (*sec & 0x0F);
*min = ((*min & 0x70) >> 4)*10 + (*min & 0x0F);
*hr =  ((*hr  & 0x30) >> 4)*10 + (*hr & 0x0F);
*week_day =(*week_day & 0x07);
*day = ((*day  & 0x30) >> 4)*10 + (*day  & 0x0F);
*mn =  ((*mn   & 0x70) >> 4)*10 + (*mn   & 0x0F);
*year =((*year & 0xF0) >> 4)*10 + (*year & 0x0F);

}



